#ifndef __Executor__
#define __Executor__
#include <vector>
#include <map>

#include "CqEventData.hpp"
#include "ConcurrentQueue.hpp"
#include "TaskThread.hpp"
#include "RdmaSalEndpoint.hpp"

class Executor
{
    int _size{0};
    std::vector<TaskThread *> *_taskThreads{NULL};
    ConcurrentQueue<struct ibv_wc *> *_taskQueue{NULL};
    std::unordered_map<uint32_t, RdmaSalEndpoint *> *_qpSalEndpointMap{NULL};

public:
    Executor(int size,std::unordered_map<uint32_t, RdmaSalEndpoint *> *_qpSalEndpointMap);
    void submit(struct ibv_wc *task);
    void getTask();
};
//long affinities[]
#endif