#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <errno.h>
#include <unordered_map>

#ifndef __RDMACLIENTENDPOINTGROUP__
#define __RDMACLIENTENDPOINTGROUP__

#include "RdmaCqProcessor.hpp"
#include "RdmaClientEndpoint.hpp"

class RdmaClientEndpointGroup
{
    RdmaCqProcessor *_cqProcessor = NULL;
    //struct rdma_cm_id *_cm_id;

    int _sendQueueSize;
    int _recvQueueSize;
    int _compQueueSize;
    int _sendMsgSize;
    int _recvMsgSize;
    int _timeoutMs;
    int _maxInLine;

    struct rdma_event_channel *_eventChannel;
    std::thread *_cmEventThread;
    bool _stop;

public:
    RdmaClientEndpointGroup(int sendQueueSize, int recvQueueSize, int compQueueSize, int sendMsgSize,
                            int recvMsgSize,int maxInLine, int timeout);
    void processCmEvents();
    void processCmEvent(struct rdma_cm_event *event);
    void start();
    struct ibv_cq *createCq(struct rdma_cm_id *id);
    RdmaClientEndpoint *createEndpoint();
    void close();

};
#endif