#ifndef __TaskThread__
#define __TaskThread__
#include "Runnable.hpp"
#include "CqEventData.hpp"

#include "ConcurrentQueue.hpp"
#include <pthread.h>
#include <iostream>
#include <queue>
#include <map>
#include "RdmaSalEndpoint.hpp"

class TaskThread
{

private:
    ConcurrentQueue<struct ibv_wc *> *_taskQueue;
    std::unordered_map<uint32_t, RdmaSalEndpoint *> *_qpSalEndpointMap;
    bool _stop{false};
    int _id;
    pthread_t thread;

public:
    TaskThread(int id, int cpu, ConcurrentQueue<struct ibv_wc *> *, std::unordered_map<uint32_t, RdmaSalEndpoint *> *_qpSalEndpointMap);
    TaskThread(int id, ConcurrentQueue<struct ibv_wc *> *, std::unordered_map<uint32_t, RdmaSalEndpoint *> *_qpSalEndpointMap);
    void replicateSalRequest(char *salRequest, uint32_t size);
    static void *run(void *object);
    void stop();
    void processEvent(struct ibv_wc *data);
    ~TaskThread();
};

#endif